﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.01
@EndOfDesignText@
'Indicator
#DesignerProperty: Key: RoundIndicator, DisplayName: Round Indicator, FieldType: Boolean, DefaultValue: True, Description: Placeholder
#DesignerProperty: Key: IndicatorColor, DisplayName: Indicator Color, FieldType: Color, DefaultValue: 0xFF4761A1, Description: Placeholder
#DesignerProperty: Key: IndicatorBackgroundColor, DisplayName: Indicator Background Color, FieldType: Color, DefaultValue: 0xFF2F343A, Description: Placeholder
#DesignerProperty: Key: IndicatorSlideAnimation, DisplayName: Indicator Slide Animation, FieldType: String, DefaultValue: NONE, List: NONE|NORMAL|STRETCH

'Tabs
#DesignerProperty: Key: TabBackgroundColor, DisplayName: Tab Background Color, FieldType: Color, DefaultValue: 0xFF2F343A, Description: Placeholder
#DesignerProperty: Key: TabClickAnimation, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday

#Event: PageChanged

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	'Views
	Private xpnl_TabArea,xpnl_PageArea,xpnl_IndicatorArea As B4XView
	Private xclv_TabArea,xclv_PageArea,xclv_IndicatorArea As CustomListView
	
	
	'Types
	Type Tabs(TabText As String,Icon As B4XBitmap,Tag As Object)
	Type Pages(Layoutfile As String)
	
	'Properties
	'Indicator
	Private RoundIndicator As Boolean = True
	Private IndicatorColor As Int = xui.Color_RGB(71, 97, 161)
	Private IndicatorBackgroundColor As Int = xui.Color_RGB(47, 52, 58)
	
	'Tabs
	Private TabBackgroundColor As Int = xui.Color_RGB(47, 52, 58)
	
	'Variables etc...
	Private list_Tabs,list_Pages As List
	Private TabCount As Int = 0
	Private CurrentTab As Int = 0
	Private tmptab As Int = 0
	
	Private toright As Boolean
	Private x0 As Float
	Public hsvTimer As Timer
	Private oldOffset As Int = 0
	
	Private haloClickAnimation As Boolean = False
	
End Sub

#Region InitializeArea


Private Sub ini_xclv_IndicatorArea
	
	Dim tmplbl As Label
	tmplbl.Initialize("")
 
	Dim tmpmap As Map
	tmpmap.Initialize
	tmpmap.Put("DividerColor",0xFFD9D7DE)
	tmpmap.Put("DividerHeight",0)
	tmpmap.Put("PressedColor",0xFF7EB4FA)
	tmpmap.Put("InsertAnimationDuration",300)
	tmpmap.Put("ListOrientation","Horizontal")
	tmpmap.Put("ShowScrollBar",False)
	
	xclv_IndicatorArea.Initialize(Me,"xclv_IndicatorArea")
	xclv_IndicatorArea.DesignerCreateView(xpnl_IndicatorArea,tmplbl,tmpmap)
	
End Sub

Private Sub xclv_IndicatorArea_ScrollChanged (Offset As Int)
	xclv_TabArea.sv.ScrollViewOffsetX=xclv_IndicatorArea.sv.ScrollViewOffsetX
End Sub
Private Sub xclv_TabArea_ScrollChanged (Offset As Int)
	xclv_IndicatorArea.sv.ScrollViewOffsetX=xclv_TabArea.sv.ScrollViewOffsetX
End Sub

Private Sub xclv_PageArea_ScrollChanged (Offset As Int)
'	Log(Offset)
	'Dim tmp_index As Int = xclv_PageArea.FindIndexFromOffset(Offset)
	'Log(Offset/(tmp_index +1))
	Dim left As Boolean = False
	If oldOffset > Offset Then'To Right - Indicator to left
		left = False
		'Log("To right")
		
		
	Else'To left - Indicator to right
			left = True
		
	End If
	oldOffset = Offset
	
	'xclv_IndicatorArea.GetPanel(0).SetLayoutAnimated(0,Offset,0,xclv_TabArea.GetPanel(xclv_TabArea.FindIndexFromOffset(Offset)).Width,5dip)
	
	For i = 0 To TabCount -1 
		
		If	(mBase.Width * i) = Offset And tmptab <> (xclv_PageArea.FindIndexFromOffset(Offset) +1) Then
			
			If left = True Then
				tmptab = tmptab +1
				Else
				tmptab = tmptab -1
			End If
			SlideIndicator(tmptab)
			PageChangeEvent
			
		Log(tmptab)
		Log("Offset: " & Offset)
		
	End If
		
	Next
	
	
'	If Offset = (mBase.Width*CurrentTab) And (xclv_PageArea.FindIndexFromOffset(Offset) +1) < > CurrentTab Then
'		CurrentTab = xclv_PageArea.FindIndexFromOffset(Offset)
'		Log("lol")
'		
'	End If
	
'	If xclv_PageArea.FindIndexFromOffset(Offset) < > CurrentTab Then
'		
'		CurrentTab = xclv_PageArea.FindIndexFromOffset(Offset)
'		Log(xclv_PageArea.FindIndexFromOffset(Offset))
'	End If
	
	'Log(xclv_PageArea.FindIndexFromOffset(Offset))
	
End Sub

Private Sub PageChangeEvent
	
	If xui.SubExists(mCallBack, mEventName & "_PageChanged", 0) Then
		CallSub(mCallBack, mEventName & "_PageChanged")
	End If
	
End Sub

Private Sub ini_xclv_TabArea
	
	Dim tmplbl As Label
	tmplbl.Initialize("")
 
	Dim tmpmap As Map
	tmpmap.Initialize
	tmpmap.Put("DividerColor",0xFFD9D7DE)
	tmpmap.Put("DividerHeight",0)
	tmpmap.Put("PressedColor",0xFF7EB4FA)
	tmpmap.Put("InsertAnimationDuration",300)
	tmpmap.Put("ListOrientation","Horizontal")
	tmpmap.Put("ShowScrollBar",False)
	
	xclv_TabArea.Initialize(Me,"xclv_TabArea")
	xclv_TabArea.DesignerCreateView(xpnl_TabArea,tmplbl,tmpmap)
	
End Sub

Private Sub ini_xclv_PageArea
	
	Dim tmplbl As Label
	tmplbl.Initialize("")
 
	Dim tmpmap As Map
	tmpmap.Initialize
	tmpmap.Put("DividerColor",0xFFD9D7DE)
	tmpmap.Put("DividerHeight",0)
	tmpmap.Put("PressedColor",0xFF7EB4FA)
	tmpmap.Put("InsertAnimationDuration",300)
	tmpmap.Put("ListOrientation","Horizontal")
	tmpmap.Put("ShowScrollBar",False)
	
	xclv_PageArea.Initialize(Me,"xclv_PageArea")
	xclv_PageArea.DesignerCreateView(xpnl_PageArea,tmplbl,tmpmap)
	
	hsvTimer.Initialize("hsvTimer", 1)
	
	Private objPages As Reflector
	objPages.Target = xclv_PageArea.sv
	objPages.SetOnTouchListener("xpnl_PageArea2_Touch")
	
End Sub

Private Sub ini_views
	
	'Initialize Views
	xpnl_TabArea = xui.CreatePanel("xpnl_TabArea")
	xpnl_IndicatorArea = xui.CreatePanel("xpnl_IndicatorArea")
	xpnl_PageArea = xui.CreatePanel("xpnl_PageArea")
	
	'AddViews
	mBase.AddView(xpnl_TabArea,0,0,mBase.Width,60dip)
	mBase.AddView(xpnl_IndicatorArea,0,55dip,mBase.Width,5dip)
	mBase.AddView(xpnl_PageArea,0,60dip,mBase.Width,mBase.Height - 60dip)
	ini_xclv_TabArea
	ini_xclv_IndicatorArea
	ini_xclv_PageArea
	
	xpnl_TabArea.Color = xui.Color_Red
	xpnl_PageArea.Color = xui.Color_Blue
	
	'Ini Lists
	list_Tabs.Initialize
	list_Pages.Initialize
	
End Sub

Private Sub ini_properties (Props As Map)
	
	
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

#End Region

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	ini_properties(Props)
  
 #If B4A
 Base_Resize(mBase.Width,mBase.Height)
 #End If
  
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
	If xpnl_TabArea.IsInitialized = False Then
		
		
		ini_views
		
	End If
  
	xpnl_TabArea.SetLayoutAnimated(0,0,0,Width,60dip)
	xpnl_IndicatorArea.SetLayoutAnimated(0,0,55dip,Width,5dip)
	xpnl_PageArea.SetLayoutAnimated(0,0,60dip,Width,Height - 60dip)
  
	xclv_TabArea.GetBase.SetLayoutAnimated(0,0,0,xpnl_TabArea.Width,xpnl_TabArea.Height)
	xclv_IndicatorArea.GetBase.SetLayoutAnimated(0,0,55dip,xpnl_IndicatorArea.Width,xpnl_IndicatorArea.Height)
	xclv_PageArea.GetBase.SetLayoutAnimated(0,0,60dip,xpnl_PageArea.Width,xpnl_PageArea.Height)
  
End Sub

#Region Properties


#End Region

#Region Events



#End Region

Private Sub xpnl_TabBackground_Click
	Dim tmpview As B4XView = Sender
	CreateHaloEffect(tmpview,tmpview.Width/2,tmpview.Height/2,xui.Color_White)
	
	xclv_PageArea.ScrollToItem(tmpview.Tag -1)
	
	SlideIndicator(tmpview.Tag)
	
	tmptab = tmpview.Tag
	PageChangeEvent
End Sub

Private Sub xclv_TabArea_ItemClick (Index As Int, Value As Object)
	If haloClickAnimation = True Then
	Dim tmpview As B4XView = xclv_TabArea.GetPanel(Index)
	CreateHaloEffect(tmpview,tmpview.Width/2,tmpview.Height/2,xui.Color_White)
	End If
	
	xclv_PageArea.ScrollToItem(Value -1)
	
	SlideIndicator(Value)
	
	tmptab = Value
	PageChangeEvent
End Sub

Private Sub SlideIndicator(Index As Int)
	
	Try
	
	Dim tmp_totalwidth As Float = 0
	For i = 0 To Index -1
	
		If i < Index -1 Then
	
			tmp_totalwidth = tmp_totalwidth + xclv_TabArea.GetPanel(i).Width
		
		End If
		
	Next
	
	xclv_IndicatorArea.GetPanel(0).SetLayoutAnimated(0,tmp_totalwidth,0,xclv_TabArea.GetPanel(Index -1).Width,5dip)
	xclv_TabArea.ScrollToItem(Index -1)
	Catch
		Log(LastException)
	End Try
	
End Sub

#Region DoSubs

Private Sub buildTab(TabText As String,Icon As B4XBitmap,TabCount2 As Int) As B4XView
	
	
	If haloClickAnimation = False Then
	Dim xpnl_TabBackground As B4XView = xui.CreatePanel("")
	Else
		Dim xpnl_TabBackground As B4XView = xui.CreatePanel("xpnl_TabBackground")
		End If
	xpnl_TabBackground.SetLayoutAnimated(0,0,0,200dip,60dip)
	xpnl_TabBackground.Color = TabBackgroundColor
	xpnl_TabBackground.Tag = TabCount2
	
	If TabText = "" And Icon.IsInitialized = False Then 'Empty Tab
		
		'Do Nothing
		
		Else If TabText = "" Then 'Only Icon
			
		Dim xpnl_TabIcon As B4XView = CreateImageView("")
		xpnl_TabBackground.AddView(xpnl_TabIcon,(xpnl_TabBackground.Width/2) - (xpnl_TabBackground.Height/2.5)/2,(xpnl_TabBackground.Height/2) - (xpnl_TabBackground.Height/2)/2,xpnl_TabBackground.Height/2,xpnl_TabBackground.Height/2)
		xpnl_TabIcon.SetBitmap(Icon.Resize(xpnl_TabIcon.Width,xpnl_TabIcon.Height,True))
			
			Else If Icon.IsInitialized = False Then 'Only Text
				
		Dim xpnl_TabText As B4XView = CreateLabel("")
		xpnl_TabBackground.AddView(xpnl_TabText,0,0,xpnl_TabBackground.Width,xpnl_TabBackground.Height)
		xpnl_TabText.Font = xui.CreateDefaultBoldFont(15)
		xpnl_TabText.SetTextAlignment("CENTER","CENTER")
		xpnl_TabText.TextColor = xui.Color_White
		xpnl_TabText.Text = TabText
		
		Else 'Icon + Text
		
		Dim xpnl_TabIcon As B4XView = CreateImageView("")
		xpnl_TabBackground.AddView(xpnl_TabIcon,(xpnl_TabBackground.Width/2) - (xpnl_TabBackground.Height/2.5)/2,5dip,xpnl_TabBackground.Height/2.5,xpnl_TabBackground.Height/2.5)
		xpnl_TabIcon.SetBitmap(Icon.Resize(xpnl_TabIcon.Width,xpnl_TabIcon.Height,True))
		
		
		Dim xpnl_TabText As B4XView = CreateLabel("")
		xpnl_TabBackground.AddView(xpnl_TabText,0,xpnl_TabBackground.Height/2 - 5dip,xpnl_TabBackground.Width,xpnl_TabBackground.Height/2 + 5dip)
		xpnl_TabText.Font = xui.CreateDefaultBoldFont(15)
		xpnl_TabText.SetTextAlignment("CENTER","CENTER")
		xpnl_TabText.TextColor = xui.Color_White
		xpnl_TabText.Text = TabText
		
		
	End If
	
	
	Return xpnl_TabBackground
	
End Sub

Public Sub AddTab(Layoutfile As String,TabText As String,Icon As B4XBitmap,Tag As Object)
	
	'CreateTab
	
	TabCount = TabCount +1
	
	Dim tmptab2 As Tabs
	tmptab2.Initialize
	tmptab2.TabText = TabText
	tmptab2.Icon = Icon
	
	list_Tabs.Add(tmptab2)
	xclv_TabArea.Add(buildTab(TabText,Icon,TabCount),TabCount)

Dim totalwidth As Float = 0

For i = 0 To xclv_TabArea.Size -1 
	
		totalwidth = totalwidth + xclv_TabArea.GetPanel(i).Width
	
Next
Dim tmp_indicatorpnl As B4XView = xui.CreatePanel("")
	tmp_indicatorpnl.SetLayoutAnimated(0,0,0,totalwidth,5dip)
	tmp_indicatorpnl.Color = IndicatorBackgroundColor
	
	
	Dim xpnl_indicator As B4XView = xui.CreatePanel("")
	tmp_indicatorpnl.AddView(xpnl_indicator,0,0,200dip,5dip)
	
	If RoundIndicator = True Then
		xpnl_indicator.SetColorAndBorder(IndicatorColor,0,xui.Color_Transparent,xpnl_indicator.Height/2)
		Else
		xpnl_indicator.SetColorAndBorder(IndicatorColor,0,xui.Color_Transparent,0)
	End If
	
	xclv_IndicatorArea.Clear
	
	xclv_IndicatorArea.Add(tmp_indicatorpnl,"")
	
	
	
	'CreatePage
	Dim xpnl_page As B4XView = xui.CreatePanel("")
	xpnl_page.SetLayoutAnimated(0,0,0,xpnl_PageArea.Width,xpnl_PageArea.Height)
	
	xpnl_page.LoadLayout(Layoutfile)
	
	
	CurrentTab = 1
	tmptab = 1
	xclv_PageArea.Add(xpnl_page,TabCount)
	
End Sub

Public Sub RemoveTab(Index As Int)
	
	Log("Comming Soon")
	
End Sub

'Get a single Tab as Panel to modify for exmaple the font of the text
Public Sub GetTab(Index As Int) As B4XView
	
	Return xclv_TabArea.GetPanel(Index)
	
End Sub

Public Sub GetPage(Index As Int) As B4XView
	
	Return xclv_PageArea.GetPanel(Index)
	
End Sub

Public Sub CenterTabs
	
	Dim newwidth As Float = mBase.Width/TabCount
	For i = 0 To xclv_TabArea.Size -1 
	
		xclv_TabArea.ResizeItem(i,newwidth)

		Dim tmp_pnl As B4XView = xclv_TabArea.GetPanel(i)
		tmp_pnl.GetView(0).SetLayoutAnimated(0,0,0,tmp_pnl.Width,tmp_pnl.Height)
	
		SlideIndicator(1)
	
		ResizeTabComponents(i)
	
	Next
	
End Sub

#End Region

Private Sub ResizeTabComponents(Index As Int)
	
	Dim tmptabs As Tabs = list_Tabs.Get(Index)
	Dim TabText As String = tmptabs.TabText
	Dim Icon As B4XBitmap = tmptabs.Icon
	Dim xpnl_TabBackground As B4XView = xclv_TabArea.GetPanel(Index)
	
	
	If TabText = "" And Icon.IsInitialized = False Then 'Empty Tab
		
		'Do Nothing
		
	Else If TabText = "" Then 'Only Icon
			
		Dim xpnl_TabIcon As B4XView = xpnl_TabBackground.GetView(0)
		
		xpnl_TabIcon.SetLayoutAnimated(0,(xpnl_TabBackground.Width/2) - (xpnl_TabBackground.Height/2.5)/2,(xpnl_TabBackground.Height/2) - (xpnl_TabBackground.Height/2)/2,xpnl_TabBackground.Height/2,xpnl_TabBackground.Height/2)
		xpnl_TabIcon.SetBitmap(Icon.Resize(xpnl_TabIcon.Width,xpnl_TabIcon.Height,True))
			
	Else If Icon.IsInitialized = False Then 'Only Text
				
		Dim xpnl_TabText As B4XView = xpnl_TabBackground.GetView(0)
		
		xpnl_TabText.SetLayoutAnimated(0,0,0,xpnl_TabBackground.Width,xpnl_TabBackground.Height)
		
		
	Else 'Icon + Text
		
		Dim xpnl_TabIcon As B4XView = xpnl_TabBackground.GetView(0)
		Dim xpnl_TabText As B4XView = xpnl_TabBackground.GetView(1)
		
		xpnl_TabIcon.SetLayoutAnimated(0,(xpnl_TabBackground.Width/2) - (xpnl_TabBackground.Height/2.5)/2,5dip,xpnl_TabBackground.Height/2.5,xpnl_TabBackground.Height/2.5)
		xpnl_TabIcon.SetBitmap(Icon.Resize(xpnl_TabIcon.Width,xpnl_TabIcon.Height,True))
		
		
	
		xpnl_TabText.SetLayoutAnimated(0,0,xpnl_TabBackground.Height/2 - 5dip,xpnl_TabBackground.Width,xpnl_TabBackground.Height/2 + 5dip)
		
		
		
	End If
	
	Dim xpnl_indicator As B4XView = xclv_IndicatorArea.GetPanel(0).GetView(0)
	xpnl_indicator.SetLayoutAnimated(0,xpnl_indicator.Left,0,xpnl_TabBackground.Width,xpnl_indicator.Height)
	
End Sub

#Region Swipe

Private Sub xpnl_PageArea2_Touch(ViewTag As Object, Action As Int, X As Float, y As Float, MotionEvent As Object) As Boolean
	
	Select Action
		
		Case 1	' ACTION_UP
				
			If x0 > x Then
				
				toright = True
				
			Else
					
				toright = False
				
			End If
			
			x0 = 0
			
			hsvTimer.Enabled = True
			
			
			
		Case 2	' ACTION_MOVE
	
			If x0 = 0 Then
				
				x0 = x
				
			End If
		
	End Select
	
	Return False


End Sub

Private Sub ScrollFinish(Pos As Int)
	
	
	
	If toright = True Then
		
		If Pos > (((CurrentTab -1) * xpnl_PageArea.Width) + xpnl_PageArea.Width/4) Then
		
			If xclv_PageArea.FindIndexFromOffset(Pos) +1 < 4 Then xclv_PageArea.ScrollToItem(xclv_PageArea.FindIndexFromOffset(Pos) +1)
		
		Else
			
			xclv_PageArea.ScrollToItem(xclv_PageArea.FindIndexFromOffset(Pos))
		
		
		End If

		

	Else
		
		If Pos > (((CurrentTab -1) * xpnl_PageArea.Width) + xpnl_PageArea.Width/1.5) Then
		
			xclv_PageArea.ScrollToItem(xclv_PageArea.FindIndexFromOffset(Pos) +1)
		
		Else
			
			xclv_PageArea.ScrollToItem(xclv_PageArea.FindIndexFromOffset(Pos))
		
		
		End If
		
	End If
	
	CurrentTab = xclv_PageArea.FindIndexFromOffset(xclv_PageArea.sv.ScrollViewOffsetX) +1
	
'	If toright = True Then
'		SlideIndicator(xclv_PageArea.LastVisibleIndex +1)
'	Else
'		SlideIndicator(xclv_PageArea.FirstVisibleIndex +1)
'		End If
		

	
End Sub

Private Sub hsvTimer_Tick
	
	hsvTimer.Enabled = False
	ScrollFinish(xclv_PageArea.sv.ScrollViewOffsetX)
	
End Sub

#End Region

#Region Functions

Private Sub CreateLabel(EventName As String) As B4XView
	
	Dim tmp_label As Label
	tmp_label.Initialize(EventName)
	Return tmp_label
	
End Sub

Private Sub CreateImageView(EventName As String) As B4XView
	
	Dim tmp_imageview As ImageView
	tmp_imageview.Initialize(EventName)
	Return tmp_imageview
	
End Sub

Private Sub getImage(B4XImageView As B4XView) As B4XBitmap
	
	Dim iv As ImageView = B4XImageView
	Dim bmp As Bitmap = iv.Bitmap
	Return bmp
	
End Sub

'https://www.b4x.com/android/forum/threads/b4x-xui-simple-halo-animation.80267/#content
Private Sub CreateHaloEffect (Parent As B4XView, x As Int, y As Int, clr As Int)
	Dim cvs As B4XCanvas
	Dim p As B4XView = xui.CreatePanel("")
	Dim radius As Int = 150dip
	p.SetLayoutAnimated(0, 0, 0, radius * 2, radius * 2)
	cvs.Initialize(p)
	cvs.DrawCircle(cvs.TargetRect.CenterX, cvs.TargetRect.CenterY, cvs.TargetRect.Width / 2, clr, True, 0)
	Dim bmp As B4XBitmap = cvs.CreateBitmap
	For i = 1 To 1
		CreateHaloEffectHelper(Parent,bmp, x, y, clr, radius)
		Sleep(800)
	Next
End Sub

Private Sub CreateHaloEffectHelper (Parent As B4XView,bmp As B4XBitmap, x As Int, y As Int, clr As Int, radius As Int)
	Dim iv As ImageView
	iv.Initialize("")
	Dim p As B4XView = iv
	p.SetBitmap(bmp)
	Parent.AddView(p, x, y, 0, 0)
	Dim duration As Int = 1000
	p.SetLayoutAnimated(duration, x - radius, y - radius, 2 * radius, 2 * radius)
	p.SetVisibleAnimated(duration, False)
	Sleep(duration)
	p.RemoveViewFromParent
End Sub

#End Region

